program calculator

%%#include <math.h>

%{
    void myCalc(
        double i1,
        double i2,
        double* o1,
        double* o2)
    {
        *o1 = sin(i1 + i2);
        *o2 = cos(i1 - i2);
    }
}%

double in1;
double in2;
double out1;
double out2;

assign in1 to "{DEV}:INPUT1";
assign in2 to "{DEV}:INPUT2";
assign out1 to "{DEV}:OUTPUT1";
assign out2 to "{DEV}:OUTPUT2";

monitor in1;
monitor in2;

evflag newInput;
sync in1 to newInput;
sync in2 to newInput;

ss calculator {
    state idle {
        when (efTestAndClear(newInput)) {
            printf ("Got new input: %#g, %#g\n", in1, in2);
            myCalc(in1, in2, &out1, &out2);
            printf ("New output: %#g, %#g\n", out1, out2);
            pvPut(out1);
            pvPut(out2);
        } state idle
    }
}

